Index: serefpolicy-contrib-20140730/kerberos.te
===================================================================
--- serefpolicy-contrib-20140730.orig/kerberos.te
+++ serefpolicy-contrib-20140730/kerberos.te
@@ -6,11 +6,11 @@ policy_module(kerberos, 1.12.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether kerberos is supported.
-##	</p>
+## <p>
+## Allow confined applications to run with kerberos.
+## </p>
 ## </desc>
-gen_tunable(allow_kerberos, false)
+gen_tunable(kerberos_enabled, false)
 
 type kadmind_t;
 type kadmind_exec_t;
@@ -35,23 +35,27 @@ init_daemon_domain(kpropd_t, kpropd_exec
 domain_obj_id_change_exemption(kpropd_t)
 
 type krb5_conf_t;
-files_type(krb5_conf_t)
+files_config_file(krb5_conf_t)
 
 type krb5_home_t;
 userdom_user_home_content(krb5_home_t)
 
-type krb5_host_rcache_t;
+type krb5_host_rcache_t alias saslauthd_tmp_t;
 files_tmp_file(krb5_host_rcache_t)
 
+# types for general configuration files in /etc
 type krb5_keytab_t;
 files_security_file(krb5_keytab_t)
 
+# types for KDC configs and principal file(s)
 type krb5kdc_conf_t;
-files_type(krb5kdc_conf_t)
+files_config_file(krb5kdc_conf_t)
 
 type krb5kdc_lock_t;
-files_type(krb5kdc_lock_t)
+files_lock_file(krb5kdc_lock_t)
 
+
+# types for KDC principal file(s)
 type krb5kdc_principal_t;
 files_type(krb5kdc_principal_t)
 
@@ -74,28 +78,31 @@ files_pid_file(krb5kdc_var_run_t)
 # kadmind local policy
 #
 
+# Use capabilities. Surplus capabilities may be allowed.
 allow kadmind_t self:capability { setuid setgid chown fowner dac_override sys_nice };
-dontaudit kadmind_t self:capability sys_tty_config;
 allow kadmind_t self:capability2 block_suspend;
+dontaudit kadmind_t self:capability sys_tty_config;
 allow kadmind_t self:process { setfscreate setsched getsched signal_perms };
 allow kadmind_t self:netlink_route_socket r_netlink_socket_perms;
-allow kadmind_t self:tcp_socket { accept listen };
+allow kadmind_t self:unix_dgram_socket { connect create write };
+allow kadmind_t self:tcp_socket connected_stream_socket_perms;
 allow kadmind_t self:udp_socket create_socket_perms;
 
-allow kadmind_t kadmind_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+allow kadmind_t kadmind_log_t:file manage_file_perms;
 logging_log_filetrans(kadmind_t, kadmind_log_t, file)
 
 allow kadmind_t krb5_conf_t:file read_file_perms;
-dontaudit kadmind_t krb5_conf_t:file write_file_perms;
+dontaudit kadmind_t krb5_conf_t:file write;
 
-read_files_pattern(kadmind_t, krb5kdc_conf_t, krb5kdc_conf_t)
-dontaudit kadmind_t krb5kdc_conf_t:file { write_file_perms setattr_file_perms };
+manage_files_pattern(kadmind_t, krb5kdc_conf_t, krb5kdc_conf_t)
 
 allow kadmind_t krb5kdc_lock_t:file { rw_file_perms setattr_file_perms };
 
 allow kadmind_t krb5kdc_principal_t:file manage_file_perms;
 filetrans_pattern(kadmind_t, krb5kdc_conf_t, krb5kdc_principal_t, file)
 
+can_exec(kadmind_t, kadmind_exec_t)
+
 manage_dirs_pattern(kadmind_t, kadmind_tmp_t, kadmind_tmp_t)
 manage_files_pattern(kadmind_t, kadmind_tmp_t, kadmind_tmp_t)
 files_tmp_filetrans(kadmind_t, kadmind_tmp_t, { file dir })
@@ -103,13 +110,15 @@ files_tmp_filetrans(kadmind_t, kadmind_t
 manage_files_pattern(kadmind_t, kadmind_var_run_t, kadmind_var_run_t)
 files_pid_filetrans(kadmind_t, kadmind_var_run_t, file)
 
-can_exec(kadmind_t, kadmind_exec_t)
-
 kernel_read_kernel_sysctls(kadmind_t)
+kernel_list_proc(kadmind_t)
 kernel_read_network_state(kadmind_t)
+kernel_read_proc_symlinks(kadmind_t)
 kernel_read_system_state(kadmind_t)
 
-corenet_all_recvfrom_unlabeled(kadmind_t)
+corecmd_exec_bin(kadmind_t)
+corecmd_exec_shell(kadmind_t)
+
 corenet_all_recvfrom_netlabel(kadmind_t)
 corenet_tcp_sendrecv_generic_if(kadmind_t)
 corenet_udp_sendrecv_generic_if(kadmind_t)
@@ -119,31 +128,41 @@ corenet_tcp_sendrecv_all_ports(kadmind_t
 corenet_udp_sendrecv_all_ports(kadmind_t)
 corenet_tcp_bind_generic_node(kadmind_t)
 corenet_udp_bind_generic_node(kadmind_t)
-
-corenet_sendrecv_all_server_packets(kadmind_t)
 corenet_tcp_bind_kerberos_admin_port(kadmind_t)
+corenet_tcp_bind_kerberos_password_port(kadmind_t)
 corenet_udp_bind_kerberos_admin_port(kadmind_t)
+corenet_udp_bind_kerberos_password_port(kadmind_t)
 corenet_tcp_bind_reserved_port(kadmind_t)
+corenet_dontaudit_tcp_bind_all_reserved_ports(kadmind_t)
+corenet_sendrecv_kerberos_admin_server_packets(kadmind_t)
+corenet_sendrecv_kerberos_password_server_packets(kadmind_t)
+corenet_tcp_connect_kprop_port(kadmind_t)
 
 dev_read_sysfs(kadmind_t)
+dev_read_rand(kadmind_t)
+dev_read_urand(kadmind_t)
 
 fs_getattr_all_fs(kadmind_t)
 fs_search_auto_mountpoints(kadmind_t)
+fs_rw_anon_inodefs_files(kadmind_t)
 
 domain_use_interactive_fds(kadmind_t)
 
-files_read_etc_files(kadmind_t)
-files_read_usr_files(kadmind_t)
+files_read_usr_symlinks(kadmind_t)
 files_read_var_files(kadmind_t)
 
 selinux_validate_context(kadmind_t)
 
+auth_read_passwd(kadmind_t)
+
 logging_send_syslog_msg(kadmind_t)
 
-miscfiles_read_localization(kadmind_t)
+miscfiles_read_generic_certs(kadmind_t)
 
+seutil_read_config(kadmind_t)
 seutil_read_file_contexts(kadmind_t)
 
+sysnet_read_config(kadmind_t)
 sysnet_use_ldap(kadmind_t)
 
 userdom_dontaudit_use_unpriv_user_fds(kadmind_t)
@@ -154,11 +173,16 @@ optional_policy(`
 ')
 
 optional_policy(`
+	dirsrv_stream_connect(kadmind_t)
+')
+
+optional_policy(`
 	nis_use_ypbind(kadmind_t)
 ')
 
 optional_policy(`
 	sssd_read_public_files(kadmind_t)
+    sssd_stream_connect(kadmind_t)
 ')
 
 optional_policy(`
@@ -174,24 +198,27 @@ optional_policy(`
 # Krb5kdc local policy
 #
 
+# Use capabilities. Surplus capabilities may be allowed.
 allow krb5kdc_t self:capability { setuid setgid net_admin chown fowner dac_override sys_nice };
-dontaudit krb5kdc_t self:capability sys_tty_config;
 allow krb5kdc_t self:capability2 block_suspend;
+dontaudit krb5kdc_t self:capability sys_tty_config;
 allow krb5kdc_t self:process { setfscreate setsched getsched signal_perms };
 allow krb5kdc_t self:netlink_route_socket r_netlink_socket_perms;
-allow krb5kdc_t self:tcp_socket { accept listen };
+allow krb5kdc_t self:tcp_socket create_stream_socket_perms;
 allow krb5kdc_t self:udp_socket create_socket_perms;
 allow krb5kdc_t self:fifo_file rw_fifo_file_perms;
 
 allow krb5kdc_t krb5_conf_t:file read_file_perms;
 dontaudit krb5kdc_t krb5_conf_t:file write;
 
+can_exec(krb5kdc_t, krb5kdc_exec_t)
+
 read_files_pattern(krb5kdc_t, krb5kdc_conf_t, krb5kdc_conf_t)
-dontaudit krb5kdc_t krb5kdc_conf_t:file write_file_perms;
+dontaudit krb5kdc_t krb5kdc_conf_t:file write;
 
 allow krb5kdc_t krb5kdc_lock_t:file { rw_file_perms setattr_file_perms };
 
-allow krb5kdc_t krb5kdc_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+allow krb5kdc_t krb5kdc_log_t:file manage_file_perms;
 logging_log_filetrans(krb5kdc_t, krb5kdc_log_t, file)
 
 allow krb5kdc_t krb5kdc_principal_t:file rw_file_perms;
@@ -201,71 +228,76 @@ manage_files_pattern(krb5kdc_t, krb5kdc_
 files_tmp_filetrans(krb5kdc_t, krb5kdc_tmp_t, { file dir })
 
 manage_files_pattern(krb5kdc_t, krb5kdc_var_run_t, krb5kdc_var_run_t)
-files_pid_filetrans(krb5kdc_t, krb5kdc_var_run_t, file)
-
-can_exec(krb5kdc_t, krb5kdc_exec_t)
+manage_sock_files_pattern(krb5kdc_t, krb5kdc_var_run_t, krb5kdc_var_run_t)
+manage_dirs_pattern(krb5kdc_t, krb5kdc_var_run_t, krb5kdc_var_run_t)
+files_pid_filetrans(krb5kdc_t, krb5kdc_var_run_t, { dir file sock_file })
 
 kernel_read_system_state(krb5kdc_t)
 kernel_read_kernel_sysctls(krb5kdc_t)
+kernel_list_proc(krb5kdc_t)
+kernel_read_proc_symlinks(krb5kdc_t)
 kernel_read_network_state(krb5kdc_t)
 kernel_search_network_sysctl(krb5kdc_t)
 
 corecmd_exec_bin(krb5kdc_t)
 
-corenet_all_recvfrom_unlabeled(krb5kdc_t)
 corenet_all_recvfrom_netlabel(krb5kdc_t)
 corenet_tcp_sendrecv_generic_if(krb5kdc_t)
 corenet_udp_sendrecv_generic_if(krb5kdc_t)
 corenet_tcp_sendrecv_generic_node(krb5kdc_t)
 corenet_udp_sendrecv_generic_node(krb5kdc_t)
+corenet_tcp_sendrecv_all_ports(krb5kdc_t)
+corenet_udp_sendrecv_all_ports(krb5kdc_t)
 corenet_tcp_bind_generic_node(krb5kdc_t)
 corenet_udp_bind_generic_node(krb5kdc_t)
-
-corenet_sendrecv_kerberos_server_packets(krb5kdc_t)
 corenet_tcp_bind_kerberos_port(krb5kdc_t)
 corenet_udp_bind_kerberos_port(krb5kdc_t)
-corenet_tcp_sendrecv_kerberos_port(krb5kdc_t)
-corenet_udp_sendrecv_kerberos_port(krb5kdc_t)
-
-corenet_sendrecv_ocsp_client_packets(krb5kdc_t)
 corenet_tcp_connect_ocsp_port(krb5kdc_t)
-corenet_tcp_sendrecv_ocsp_port(krb5kdc_t)
+corenet_sendrecv_kerberos_server_packets(krb5kdc_t)
+corenet_sendrecv_ocsp_client_packets(krb5kdc_t)
 
 dev_read_sysfs(krb5kdc_t)
+dev_read_urand(krb5kdc_t)
 
 fs_getattr_all_fs(krb5kdc_t)
 fs_search_auto_mountpoints(krb5kdc_t)
+fs_rw_anon_inodefs_files(krb5kdc_t)
 
 domain_use_interactive_fds(krb5kdc_t)
 
-files_read_etc_files(krb5kdc_t)
 files_read_usr_symlinks(krb5kdc_t)
 files_read_var_files(krb5kdc_t)
 
 selinux_validate_context(krb5kdc_t)
 
+auth_read_passwd(krb5kdc_t)
+
 logging_send_syslog_msg(krb5kdc_t)
 
 miscfiles_read_generic_certs(krb5kdc_t)
-miscfiles_read_localization(krb5kdc_t)
 
 seutil_read_file_contexts(krb5kdc_t)
 
+sysnet_read_config(krb5kdc_t)
 sysnet_use_ldap(krb5kdc_t)
 
 userdom_dontaudit_use_unpriv_user_fds(krb5kdc_t)
 userdom_dontaudit_search_user_home_dirs(krb5kdc_t)
 
 optional_policy(`
+    ipa_stream_connect_otpd(krb5kdc_t)
+')
+
+optional_policy(`
 	ldap_stream_connect(krb5kdc_t)
 ')
 
 optional_policy(`
-	nis_use_ypbind(krb5kdc_t)
+	dirsrv_stream_connect(krb5kdc_t)
 ')
 
 optional_policy(`
-	sssd_read_public_files(krb5kdc_t)
+	nis_use_ypbind(krb5kdc_t)
 ')
 
 optional_policy(`
@@ -273,6 +305,10 @@ optional_policy(`
 ')
 
 optional_policy(`
+	sssd_read_public_files(krb5kdc_t)
+')
+
+optional_policy(`
 	udev_read_db(krb5kdc_t)
 ')
 
@@ -281,10 +317,12 @@ optional_policy(`
 # kpropd local policy
 #
 
+allow kpropd_t self:capability net_bind_service;
 allow kpropd_t self:process setfscreate;
-allow kpropd_t self:fifo_file rw_fifo_file_perms;
-allow kpropd_t self:unix_stream_socket { accept listen };
-allow kpropd_t self:tcp_socket { accept listen };
+
+allow kpropd_t self:fifo_file rw_file_perms;
+allow kpropd_t self:unix_stream_socket create_stream_socket_perms;
+allow kpropd_t self:tcp_socket create_stream_socket_perms;
 
 allow kpropd_t krb5_host_rcache_t:file manage_file_perms;
 
@@ -303,26 +341,20 @@ files_tmp_filetrans(kpropd_t, krb5kdc_tm
 
 corecmd_exec_bin(kpropd_t)
 
-corenet_all_recvfrom_unlabeled(kpropd_t)
 corenet_tcp_sendrecv_generic_if(kpropd_t)
 corenet_tcp_sendrecv_generic_node(kpropd_t)
+corenet_tcp_sendrecv_all_ports(kpropd_t)
 corenet_tcp_bind_generic_node(kpropd_t)
-
-corenet_sendrecv_kprop_server_packets(kpropd_t)
 corenet_tcp_bind_kprop_port(kpropd_t)
-corenet_tcp_sendrecv_kprop_port(kpropd_t)
 
 dev_read_urand(kpropd_t)
 
-files_read_etc_files(kpropd_t)
 files_search_tmp(kpropd_t)
 
 selinux_validate_context(kpropd_t)
 
 logging_send_syslog_msg(kpropd_t)
 
-miscfiles_read_localization(kpropd_t)
-
 seutil_read_file_contexts(kpropd_t)
 
 sysnet_dns_name_resolve(kpropd_t)
Index: serefpolicy-contrib-20140730/kerneloops.if
===================================================================
--- serefpolicy-contrib-20140730.orig/kerneloops.if
+++ serefpolicy-contrib-20140730/kerneloops.if
@@ -101,13 +101,16 @@ interface(`kerneloops_manage_tmp_files',
 #
 interface(`kerneloops_admin',`
 	gen_require(`
-		type kerneloops_t, kerneloops_initrc_exec_t;
-		type kerneloops_tmp_t;
+		type kerneloops_t, kerneloops_initrc_exec_t, kerneloops_tmp_t;
 	')
 
-	allow $1 kerneloops_t:process { ptrace signal_perms };
+	allow $1 kerneloops_t:process signal_perms;
 	ps_process_pattern($1, kerneloops_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 kerneloops_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, kerneloops_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 kerneloops_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/kerneloops.te
===================================================================
--- serefpolicy-contrib-20140730.orig/kerneloops.te
+++ serefpolicy-contrib-20140730/kerneloops.te
@@ -31,7 +31,6 @@ kernel_read_ring_buffer(kerneloops_t)
 
 domain_use_interactive_fds(kerneloops_t)
 
-corenet_all_recvfrom_unlabeled(kerneloops_t)
 corenet_all_recvfrom_netlabel(kerneloops_t)
 corenet_tcp_sendrecv_generic_if(kerneloops_t)
 corenet_tcp_sendrecv_generic_node(kerneloops_t)
@@ -45,8 +44,6 @@ auth_use_nsswitch(kerneloops_t)
 logging_send_syslog_msg(kerneloops_t)
 logging_read_generic_logs(kerneloops_t)
 
-miscfiles_read_localization(kerneloops_t)
-
 optional_policy(`
 	dbus_system_domain(kerneloops_t, kerneloops_exec_t)
 ')
Index: serefpolicy-contrib-20140730/keyboardd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/keyboardd.if
+++ serefpolicy-contrib-20140730/keyboardd.if
@@ -1,19 +1,39 @@
-## <summary>Xorg.conf keyboard layout callout.</summary>
 
-######################################
+## <summary>policy for system-setup-keyboard daemon</summary>
+
+########################################
 ## <summary>
-##	Read keyboardd unnamed pipes.
+##	Execute a domain transition to run keyboard setup daemon.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed access.
-##	</summary>
+## </summary>
 ## </param>
 #
-interface(`keyboardd_read_pipes',`
+interface(`keyboardd_domtrans',`
 	gen_require(`
-		type keyboardd_t;
+		type keyboardd_t, keyboardd_exec_t;
+	')
+
+	domtrans_pattern($1, keyboardd_exec_t, keyboardd_t)
+')
+
+######################################
+## <summary>
+##  Allow attempts to read  to
+##  keyboardd unnamed pipes.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`keyboardd_read_pipes',`
+    gen_require(`
+            type keyboardd_t;
 	')
 
-	allow $1 keyboardd_t:fifo_file read_fifo_file_perms;
+    allow $1 keyboardd_t:fifo_file read_fifo_file_perms;
 ')
Index: serefpolicy-contrib-20140730/keyboardd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/keyboardd.te
+++ serefpolicy-contrib-20140730/keyboardd.te
@@ -19,6 +19,3 @@ allow keyboardd_t self:unix_stream_socke
 
 files_manage_etc_runtime_files(keyboardd_t)
 files_etc_filetrans_etc_runtime(keyboardd_t, file)
-files_read_etc_files(keyboardd_t)
-
-miscfiles_read_localization(keyboardd_t)
Index: serefpolicy-contrib-20140730/keystone.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/keystone.fc
+++ serefpolicy-contrib-20140730/keystone.fc
@@ -1,3 +1,5 @@
+/usr/lib/systemd/system/openstack-keystone.*		--	gen_context(system_u:object_r:keystone_unit_file_t,s0)
+
 /etc/rc\.d/init\.d/openstack-keystone	--	gen_context(system_u:object_r:keystone_initrc_exec_t,s0)
 
 /usr/bin/keystone-all	--	gen_context(system_u:object_r:keystone_exec_t,s0)
Index: serefpolicy-contrib-20140730/keystone.if
===================================================================
--- serefpolicy-contrib-20140730.orig/keystone.if
+++ serefpolicy-contrib-20140730/keystone.if
@@ -1,42 +1,218 @@
-## <summary>Python implementation of the OpenStack identity service API.</summary>
+
+## <summary>policy for keystone</summary>
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an keystone environment.
+##	Transition to keystone.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`keystone_domtrans',`
+	gen_require(`
+		type keystone_t, keystone_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, keystone_exec_t, keystone_t)
+')
+########################################
+## <summary>
+##	Read keystone's log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+## <rolecap/>
+#
+interface(`keystone_read_log',`
+	gen_require(`
+		type keystone_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, keystone_log_t, keystone_log_t)
+')
+
+########################################
+## <summary>
+##	Append to keystone log files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_append_log',`
+	gen_require(`
+		type keystone_log_t;
+	')
+
+	logging_search_logs($1)
+	append_files_pattern($1, keystone_log_t, keystone_log_t)
+')
+
+########################################
+## <summary>
+##	Manage keystone log files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_manage_log',`
+	gen_require(`
+		type keystone_log_t;
+	')
+
+	logging_search_logs($1)
+	manage_dirs_pattern($1, keystone_log_t, keystone_log_t)
+	manage_files_pattern($1, keystone_log_t, keystone_log_t)
+	manage_lnk_files_pattern($1, keystone_log_t, keystone_log_t)
+')
+
+########################################
+## <summary>
+##	Search keystone lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_search_lib',`
+	gen_require(`
+		type keystone_var_lib_t;
+	')
+
+	allow $1 keystone_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read keystone lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_read_lib_files',`
+	gen_require(`
+		type keystone_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	read_files_pattern($1, keystone_var_lib_t, keystone_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage keystone lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_manage_lib_files',`
+	gen_require(`
+		type keystone_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, keystone_var_lib_t, keystone_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage keystone lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`keystone_manage_lib_dirs',`
+	gen_require(`
+		type keystone_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, keystone_var_lib_t, keystone_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Execute keystone server in the keystone domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`keystone_systemctl',`
+	gen_require(`
+		type keystone_t;
+		type keystone_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	systemd_read_fifo_file_passwd_run($1)
+	allow $1 keystone_unit_file_t:file read_file_perms;
+	allow $1 keystone_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, keystone_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an keystone environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
 interface(`keystone_admin',`
 	gen_require(`
-		type keystone_t, keystone_initrc_exec_t, keystone_log_t;
-		type keystone_var_lib_t, keystone_tmp_t;
+		type keystone_t;
+		type keystone_log_t;
+		type keystone_var_lib_t;
+		type keystone_unit_file_t;
 	')
 
 	allow $1 keystone_t:process { ptrace signal_perms };
 	ps_process_pattern($1, keystone_t)
 
-	init_labeled_script_domtrans($1, keystone_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 keystone_initrc_exec_t system_r;
-	allow $2 system_r;
-
 	logging_search_logs($1)
 	admin_pattern($1, keystone_log_t)
 
 	files_search_var_lib($1)
 	admin_pattern($1, keystone_var_lib_t)
 
-	files_search_tmp($1)
-	admin_pattern($1, keystone_tmp_t)
+	keystone_systemctl($1)
+	admin_pattern($1, keystone_unit_file_t)
+	allow $1 keystone_unit_file_t:service all_service_perms;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
Index: serefpolicy-contrib-20140730/keystone.te
===================================================================
--- serefpolicy-contrib-20140730.orig/keystone.te
+++ serefpolicy-contrib-20140730/keystone.te
@@ -21,10 +21,14 @@ files_type(keystone_var_lib_t)
 type keystone_tmp_t;
 files_tmp_file(keystone_tmp_t)
 
+type keystone_unit_file_t;
+systemd_unit_file(keystone_unit_file_t)
+
 ########################################
 #
 # Local policy
 #
+allow keystone_t self:process { getsched setsched };
 
 allow keystone_t self:fifo_file rw_fifo_file_perms;
 allow keystone_t self:unix_stream_socket { accept listen };
@@ -57,20 +61,36 @@ corenet_all_recvfrom_netlabel(keystone_t
 corenet_tcp_sendrecv_generic_if(keystone_t)
 corenet_tcp_sendrecv_generic_node(keystone_t)
 corenet_tcp_bind_generic_node(keystone_t)
+corenet_tcp_connect_mysqld_port(keystone_t)
+corenet_tcp_connect_ldap_port(keystone_t)
+corenet_tcp_connect_keystone_port(keystone_t)
+corenet_tcp_connect_amqp_port(keystone_t)
+corenet_tcp_connect_osapi_compute_port(keystone_t)
 
 corenet_sendrecv_commplex_main_server_packets(keystone_t)
 corenet_tcp_bind_commplex_main_port(keystone_t)
 corenet_tcp_sendrecv_commplex_main_port(keystone_t)
 
-files_read_usr_files(keystone_t)
+corenet_tcp_bind_keystone_port(keystone_t)
 
 auth_use_pam(keystone_t)
 
 libs_exec_ldconfig(keystone_t)
 
-miscfiles_read_localization(keystone_t)
+optional_policy(`
+	ldap_stream_connect(keystone_t)
+')
 
 optional_policy(`
 	mysql_stream_connect(keystone_t)
 	mysql_tcp_connect(keystone_t)
+	mysql_read_db_lnk_files(keystone_t)
+')
+
+optional_policy(`
+	postgresql_stream_connect(keystone_t)
+')
+
+optional_policy(`
+    rpm_exec(keystone_t)
 ')
Index: serefpolicy-contrib-20140730/kismet.if
===================================================================
--- serefpolicy-contrib-20140730.orig/kismet.if
+++ serefpolicy-contrib-20140730/kismet.if
@@ -283,7 +283,7 @@ interface(`kismet_manage_log',`
 interface(`kismet_admin',`
 	gen_require(`
 		type kismet_t, kismet_var_lib_t, kismet_var_run_t;
-		type kismet_log_t, kismet_tmp_t;
+		type kismet_log_t, kismet_tmp_t, kismet_initrc_exec_t;
 	')
 
 	init_labeled_script_domtrans($1, kismet_initrc_exec_t)
@@ -292,7 +292,11 @@ interface(`kismet_admin',`
 	allow $2 system_r;
 
 	ps_process_pattern($1, kismet_t)
-	allow $1 kismet_t:process { ptrace signal_perms };
+	allow $1 kismet_t:process signal_perms;
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 kismet_t:process ptrace;
+	')
 
 	files_search_var_lib($1)
 	admin_pattern($1, kismet_var_lib_t)
Index: serefpolicy-contrib-20140730/kismet.te
===================================================================
--- serefpolicy-contrib-20140730.orig/kismet.te
+++ serefpolicy-contrib-20140730/kismet.te
@@ -81,25 +81,22 @@ kernel_read_network_state(kismet_t)
 
 corecmd_exec_bin(kismet_t)
 
-corenet_all_recvfrom_unlabeled(kismet_t)
 corenet_all_recvfrom_netlabel(kismet_t)
 corenet_tcp_sendrecv_generic_if(kismet_t)
 corenet_tcp_sendrecv_generic_node(kismet_t)
 corenet_tcp_bind_generic_node(kismet_t)
 
-corenet_sendrecv_kismet_server_packets(kismet_t)
-corenet_tcp_bind_kismet_port(kismet_t)
-corenet_sendrecv_kismet_client_packets(kismet_t)
-corenet_tcp_connect_kismet_port(kismet_t)
-corenet_tcp_sendrecv_kismet_port(kismet_t)
+corenet_tcp_connect_pulseaudio_port(kismet_t)
 
-auth_use_nsswitch(kismet_t)
-
-files_read_usr_files(kismet_t)
+corenet_sendrecv_rtsclient_server_packets(kismet_t)
+corenet_tcp_bind_rtsclient_port(kismet_t)
+corenet_sendrecv_rtsclient_client_packets(kismet_t)
+corenet_tcp_connect_rtsclient_port(kismet_t)
 
-miscfiles_read_localization(kismet_t)
+auth_use_nsswitch(kismet_t)
 
-userdom_use_user_terminals(kismet_t)
+userdom_use_inherited_user_terminals(kismet_t)
+userdom_read_user_tmp_files(kismet_t)
 
 optional_policy(`
 	dbus_system_bus_client(kismet_t)
Index: serefpolicy-contrib-20140730/kmscon.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/kmscon.fc
@@ -0,0 +1,3 @@
+/usr/bin/kmscon              --      gen_context(system_u:object_r:kmscon_exec_t,s0)
+/usr/lib/systemd/system/kmscon.*\.*      --      gen_context(system_u:object_r:kmscon_unit_file_t,s0)
+/etc/kmscon(/.*)?                                      gen_context(system_u:object_r:kmscon_conf_t,s0)
Index: serefpolicy-contrib-20140730/kmscon.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/kmscon.if
@@ -0,0 +1,24 @@
+## <summary>Terminal emulator for Linux graphical console</summary>
+
+########################################
+## <summary>
+##     Execute kmscon in the kmscon domain.
+## </summary>
+## <param name="domain">
+##     <summary>
+##     Domain allowed to transition.
+##     </summary>
+## </param>
+#
+interface(`kmscon_systemctl',`
+       gen_require(`
+               type kmscon_unit_file_t;
+               type kmscon_t;
+       ')
+
+       systemd_exec_systemctl($1)
+       allow $1 kmscon_unit_file_t:file read_file_perms;
+       allow $1 kmscon_unit_file_t:service manage_service_perms;
+
+       ps_process_pattern($1, kmscon_t)
+')
Index: serefpolicy-contrib-20140730/kmscon.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/kmscon.te
@@ -0,0 +1,86 @@
+# KMSCon SELinux policy module
+# Contributed by Lubomir Rintel <lkundrak@v3.sk>
+
+########################################
+#
+# Declarations
+#
+policy_module(kmscon, 1.0)
+
+type kmscon_t;
+type kmscon_exec_t;
+init_daemon_domain(kmscon_t, kmscon_exec_t)
+
+type kmscon_conf_t;
+files_config_file(kmscon_conf_t)
+
+type kmscon_unit_file_t;
+systemd_unit_file(kmscon_unit_file_t)
+
+type kmscon_devpts_t;
+term_pty(kmscon_devpts_t)
+# Label this as t, so that login_t can read our terminal with use_all_ttys()
+term_tty(kmscon_devpts_t)
+
+########################################
+#
+# zoneminder local policy
+#
+
+# Switch the VT into a graphics mode ; Set DRM master
+allow kmscon_t self:capability {sys_admin sys_tty_config};
+
+dontaudit kmscon_t self:capability2 block_suspend;
+
+# Create an udev monitor
+allow kmscon_t self:netlink_kobject_uevent_socket { bind create setopt getattr };
+
+allow kmscon_t kmscon_devpts_t:chr_file { rw_chr_file_perms setattr_chr_file_perms };
+term_create_pty(kmscon_t, kmscon_devpts_t)
+
+list_dirs_pattern(kmscon_t, kmscon_conf_t, kmscon_conf_t)
+read_files_pattern(kmscon_t, kmscon_conf_t, kmscon_conf_t)
+
+auth_read_passwd(kmscon_t)
+
+dev_rw_dri(kmscon_t)
+dev_read_sysfs(kmscon_t)
+dev_read_framebuffer(kmscon_t)
+dev_write_framebuffer(kmscon_t)
+dev_rw_input_dev(kmscon_t)
+
+# Get allowed path length for directory with modules
+fs_getattr_xattr_fs(kmscon_t)
+
+locallogin_domtrans(kmscon_t)
+
+miscfiles_read_fonts(kmscon_t)
+miscfiles_manage_fonts_cache(kmscon_t)
+
+# Open the tty, so that it can be handed over to the seat manager
+term_use_unallocated_ttys(kmscon_t)
+
+optional_policy(`
+    # Learn about the input devices
+    udev_read_db(kmscon_t)
+')
+
+optional_policy(`
+    # Fontconfig and Pango configuration
+    gnome_read_home_config(kmscon_t)
+')
+
+optional_policy(`
+    dbus_system_bus_client(kmscon_t)
+    init_dbus_chat(kmscon_t)
+
+    optional_policy(`
+        systemd_dbus_chat_logind(kmscon_t)
+
+        # List seats
+        systemd_login_list_pid_dirs(kmscon_t)
+        systemd_login_read_pid_files(kmscon_t)
+
+        kmscon_systemctl(systemd_logind_t)
+    ')
+')
Index: serefpolicy-contrib-20140730/ksmtuned.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/ksmtuned.fc
+++ serefpolicy-contrib-20140730/ksmtuned.fc
@@ -1,5 +1,7 @@
 /etc/rc\.d/init\.d/ksmtuned	--	gen_context(system_u:object_r:ksmtuned_initrc_exec_t,s0)
 
+/usr/lib/systemd/system/ksmtuned.*  --     gen_context(system_u:object_r:ksmtuned_unit_file_t,s0)
+
 /usr/sbin/ksmtuned	--	gen_context(system_u:object_r:ksmtuned_exec_t,s0)
 
 /var/log/ksmtuned.*	gen_context(system_u:object_r:ksmtuned_log_t,s0)
Index: serefpolicy-contrib-20140730/ksmtuned.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ksmtuned.if
+++ serefpolicy-contrib-20140730/ksmtuned.if
@@ -38,6 +38,29 @@ interface(`ksmtuned_initrc_domtrans',`
 	init_labeled_script_domtrans($1, ksmtuned_initrc_exec_t)
 ')
 
+#######################################
+## <summary>
+##  Execute ksmtuned server in the ksmtunedd domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`ksmtuned_systemctl',`
+    gen_require(`
+        type ksmtuned_unit_file_t;
+        type ksmtuned_t;
+    ')
+
+    systemd_exec_systemctl($1)
+    allow $1 ksmtuned_unit_file_t:file read_file_perms;
+    allow $1 ksmtuned_unit_file_t:service manage_service_perms;
+
+    ps_process_pattern($1, ksmtuned_t)
+')
+
 ########################################
 ## <summary>
 ##	All of the rules required to
@@ -48,30 +71,28 @@ interface(`ksmtuned_initrc_domtrans',`
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
 ## <rolecap/>
 #
 interface(`ksmtuned_admin',`
 	gen_require(`
-		type ksmtuned_t, ksmtuned_var_run_t;
-		type ksmtuned_initrc_exec_t, ksmtuned_log_t;
+		type ksmtuned_t, ksmtuned_var_run_t, ksmtuned_initrc_exec_t, ksmtuned_unit_file_t;
+		type ksmtuned_log_t;
 	')
 
-	ksmtuned_initrc_domtrans($1)
-	domain_system_change_exemption($1)
-	role_transition $2 ksmtuned_initrc_exec_t system_r;
-	allow $2 system_r;
-
-	allow $1 ksmtuned_t:process { ptrace signal_perms };
+	allow $1 ksmtuned_t:process signal_perms;
 	ps_process_pattern($1, ksmtuned_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 ksmtuned_t:process ptrace;
+	')
+
 	files_list_pids($1)
 	admin_pattern($1, ksmtuned_var_run_t)
 
 	logging_search_logs($1)
 	admin_pattern($1, ksmtuned_log_t)
+
+	ksmtuned_systemctl($1)
+	admin_pattern($1, ksmtuned_unit_file_t)
+	allow $1 ksmtuned_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/ksmtuned.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ksmtuned.te
+++ serefpolicy-contrib-20140730/ksmtuned.te
@@ -1,14 +1,31 @@
-policy_module(ksmtuned, 1.2.0)
+policy_module(ksmtuned, 1.1.1)
 
 ########################################
 #
 # Declarations
 #
 
+## <desc>
+## <p>
+## Allow ksmtuned to use nfs file systems
+## </p>
+## </desc>
+gen_tunable(ksmtuned_use_nfs, false)
+
+## <desc>
+## <p>
+## Allow ksmtuned to use cifs/Samba file systems
+## </p>
+## </desc>
+gen_tunable(ksmtuned_use_cifs, false)
+
 type ksmtuned_t;
 type ksmtuned_exec_t;
 init_daemon_domain(ksmtuned_t, ksmtuned_exec_t)
 
+type ksmtuned_unit_file_t;
+systemd_unit_file(ksmtuned_unit_file_t)
+
 type ksmtuned_initrc_exec_t;
 init_script_file(ksmtuned_initrc_exec_t)
 
@@ -43,6 +60,7 @@ corecmd_exec_shell(ksmtuned_t)
 dev_rw_sysfs(ksmtuned_t)
 
 domain_read_all_domains_state(ksmtuned_t)
+domain_dontaudit_read_all_domains_state(ksmtuned_t)
 
 mls_file_read_to_clearance(ksmtuned_t)
 
@@ -52,4 +70,11 @@ auth_use_nsswitch(ksmtuned_t)
 
 logging_send_syslog_msg(ksmtuned_t)
 
-miscfiles_read_localization(ksmtuned_t)
+tunable_policy(`ksmtuned_use_nfs',`
+    fs_read_nfs_files(ksmtuned_t)
+')
+
+tunable_policy(`ksmtuned_use_cifs',`
+    fs_read_cifs_files(ksmtuned_t)
+	samba_read_share_files(ksmtuned_t)
+')
